// Taken from ac3fix.exe v0.3 for MS-DOS

#include <fcntl.h>
//#include <sys/stat.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <PLstringfuncs.h>
#include "ac3fix.h"
#include "a52.h"
#include "mAC3dec.h"


// Dialog Item
long long inputEOF;
long badFrames;


extern Decoder* Mac3dec;
extern EventRecord Event;


/*
 * Check given file for bad frames, write good ones
 * to output file.  Harness the good energy.  Block out
 * the bad.  Harness, Good, Block, Bad.  You have to feel it.
 * Feel the Flow.  It's circular.  Like a carousel.
 * You pay your quarter and it goes up and down and around.
 * Circular.  Feel it.  All good things.
 * 
 */
void checkFile(SInt16 fOpenRef, short fSaveRefNum)
{
	OSErr theErr;
	
 	long long fpos; // file position
 	long flen; // length of frame
 	char *buf; // buffer for one frame
 	char *bufold; // buffer for last frame
 	char synctest[2]; // two byte buffer for check sync bytes
 	char badframe; // set to 1 if a bad frame was detected
 	unsigned long fnum; // number of current frame
 	unsigned long actl; // length of last read frame
 	long wrong; // operation is wrong by this number of bytes
 	
 	unsigned long bytesRead; // my own var for number of bytes read
 	long long theFPos, actlBig;

	badFrames = 0;

 	badframe = 0;
 	wrong = 0;
	
	// Set ourselves up at the beginning of the input file
	theErr = FSSetForkPosition(fOpenRef, fsFromStart, 0);
		if (theErr != noErr) HandleError("\pCould not SetFPos on input file", theErr, true);

	// get frame length
	flen = getFrameLength(fOpenRef);
	if (flen == 0) {
		HandleError("\pCannot determine frame length", theErr, true);
		//return 2;
		return;
	} else {
		//printf("Frame length is %d\n", flen);
	}
 
 	// allocate frame buffer
 	/*
 	if ((buf = (char *)malloc(flen)) == NULL) {
 		HandleError("\pCannot allocate buffer for frame", flen);
    	//	return 2;
    	return;
 	}
 	if ((bufold = (char *)malloc(flen)) == NULL) {
 		HandleError("\pCannot allocate buffer for frame", flen);
    	//	return 2;
    	return;
 	} */
 	
 	buf = NewPtr(flen);
 		if (MemError() || buf == nil) HandleError("\pCould not allocate memory for buffer", 0, true);
 	bufold = NewPtr(flen);
 		if (MemError() || bufold == nil) HandleError("\pCould not allocate memory for buffer", 0, true);

	seekSync(fOpenRef);

 	fnum = 1;

	// For EOF-testing
	FSGetForkPosition(fOpenRef, &theFPos);
	FSGetForkSize(fOpenRef, &inputEOF);  // EOF doesn't change, so we only need it once.

 	// until end of file:
 	// go flen bytes forward, check for sync bytes
 	while (theFPos != inputEOF && Mac3dec->state > kStateIdle)
 	{   		
       		//printf("Checking frame %i: ", ++fnum);
			
			FSGetForkPosition(fOpenRef, &fpos);
/*       		if ((fpos = ftell(fin)) == -1) {
          		//printf("ftell failed\n");
          		return 2;
       		} */

		// read frame length bytes
		//actl = fread(buf, 1, flen, fin);
		FSReadFork(fOpenRef, fsAtMark, 0, flen, buf, &actl);
		
		if (actl == flen) {
			// read successful
			
			// test next 2 bytes for sync
			FSReadFork(fOpenRef, fsAtMark, 0, 2, &synctest, &bytesRead);

			// For EOF-testing
			FSGetForkPosition(fOpenRef, &theFPos);
			
			if (bytesRead != 2) {
				if (theFPos != inputEOF) {
					// error
					HandleError("\pCould not read next sync", 0, true);
					//return 2;
					return;
				} else {
					// this was the last frame of the file
					//printf("OK\r");
					writeBuf(fSaveRefNum, buf, flen);
				}
			} else {
				// next two 2 bytes read, check for sync
				if (synctest[0]==0x0b && synctest[1]==0x77) {
					// frame has correct length, write it
					writeBuf(fSaveRefNum, buf, flen);
					// go back 2 bytes, file position is now on next sync
					//fseek(fin, -2, SEEK_CUR);
					FSSetForkPosition(fOpenRef, fsFromMark, -2);
				} else {
					// frame has wrong length
					badframe = 1;
					badFrames++;
					
					// go back after last sync
					//fseek(fin, fpos + 2, SEEK_SET);
					FSSetForkPosition(fOpenRef, fsFromStart, fpos + 2);
					
					// find next sync
					if (seekSync(fOpenRef)!=0) {
						//HandleError("\pseekSync failed, exiting", fpos, true);
						//return 2;
						Mac3dec->state = kStateDone;
					}
					
					// file position is now at start of next sync
					// calculate actual frame length
					FSGetForkPosition(fOpenRef, &actlBig);
					actl = (unsigned long) actlBig;
					actl -= fpos;
					//actl = ftell(fin) - fpos;
					//printf("Wrong frame length, expected %d, got %d\n", 
						//fpos, flen, actl);
					
					// calculate wrongness if frame is not written
					wrong = wrong - actl;
					// can wrong be made lower by writing frame?
					while (abs(wrong) > abs(wrong + flen)) {
						// yes, write frame
						wrong = wrong + flen;
						//printf("Writing frame\n");

						// if actual frame is longer than expected, 
						// write flen bytes of actual frame
						if (actl > flen) {
							writeBuf(fSaveRefNum, buf, flen);
						} else {
							// write last frame again
							writeBuf(fSaveRefNum, bufold, flen);
						}
					}
					//printf("Current wrongness is %d bytes\n", wrong);
				}
			}
			
		} else {
			// For EOF-testing
			FSGetForkPosition(fOpenRef, &theFPos);

			// could not read enough bytes
			if (theFPos == inputEOF) {
				// last frame not long enough, skip it
			} else {
				// a real error
				HandleError("\pCould not read next frame", fpos, true);
			}
		}
		
		// save frame
		memcpy(bufold, buf, flen);
		//BlockMove(bufold, buf, flen);
		
		// For EOF-testing
		FSGetForkPosition(fOpenRef, &theFPos);
	}
	
	// Write the last frame
	// Shrink bytesWritten first so we don't overshoot the file
	flen -= actl;
	writeBuf(fSaveRefNum, buf, flen);
	
	// Kill the buffer memory
	DisposePtr(buf);
	DisposePtr(bufold);
	
 	// finished
 	//fclose(fout);
 	//fclose(fin);
 	FSCloseFork(fOpenRef);
 	FSClose    (fSaveRefNum);
 	
 	//printf("\nFinished.");
 	if (badframe == 0) {
 		//printf(" No bad frames encountered\n");
 	} else {
 		//printf(" Found bad frames. Final wrongness is %d bytes\n", wrong);
 	}

 	//return (badframe == 1 ? 1 : 0);
}


/*
 * Seek next synchronization bytes
 * File position is set to beginning of those
 *
 * Returns: 0 if ok, 1 on error
 */
char seekSync(SInt16 fRef)
{
 unsigned long bytesRead;
 char synctest[2];
 long long theFPos;
synctest[0] = 0;
synctest[1] = 0;

// For EOF-testing
FSGetForkPosition(fRef, &theFPos);
FSGetForkSize(fRef, &inputEOF);

 while (theFPos != inputEOF && Mac3dec->state > kStateIdle && (synctest[0] != 0x0b || synctest[1] != 0x77))
 {  	FSReadFork(fRef, fsAtMark, 0, 2, &synctest, &bytesRead);
       if (bytesRead != 2) {
          //printf("ERROR: fread seekSync failed\n");
          return 1;
       }
       FSSetForkPosition(fRef, fsFromMark, -1);
       /*if (fseek(file, -1, SEEK_CUR) != 0) {
          printf("ERROR: fseek seekSync failed\n");
          return 1;
       } */

 	// For EOF-testing
	FSGetForkPosition(fRef, &theFPos);

	// Generic Event Handling just in case the seekSync chokes and doesn't find the frame headers (maybe 'cuz they ain't there)
	//if (WaitNextEvent(everyEvent, &Event, 1, 0L))
	//	Mac3dec->HandleEvent(&Event);
 }
 // file position is now 1 byte behind sync
 FSSetForkPosition(fRef, fsFromMark, -1);
 /*
 if (fseek(file, -1, SEEK_CUR) != 0) {
    printf("ERROR: fseek 2 seekSync failed\n");
    return 1;
 } */

 return 0;
}


/*
 * Get length of frame by finding the
 * first two frames
 *
 * Returns: Length of frame, 0 on error
 */
int getFrameLength(SInt16 fRef)
{
	OSErr theErr;
	long long fpos, fpos2;

	// find first frame
	seekSync(fRef);
	theErr = FSGetForkPosition(fRef, &fpos);
		if (theErr != theErr) return 0;
 	/*if ((fpos = ftell(file)) == -1) {
    		// error
    		return 0;
 	} */
 	//fseek(file, 2, SEEK_CUR);
 	FSSetForkPosition(fRef, fsFromMark, 2);

 	// find second frame
 	seekSync(fRef);
 	theErr = FSGetForkPosition(fRef, &fpos2);
 		if (theErr != theErr) return 0;
 	/*if ((fpos2 = ftell(file)) == -1) {
    		return 0;
 	} */
 	
 	// reset file position to beginning
 	//fseek(file, 0, SEEK_SET);
 	FSSetForkPosition(fRef, fsFromStart, 0);

 	// calc frame length
 	return (fpos2 - fpos);
}



/*
 * Write buffer to output file
 */
void writeBuf(short fRefNum, char *buf, long len)
{
	long bytesWritten = len;
	long fixEOF;
	static long oldBadFrames;
	Str255 theString;
	double progressBarVal; // Me = Lazy 
	
	//fwrite(buf, 1, len, out);
	FSWrite(fRefNum, &bytesWritten, buf);

	GetEOF(fRefNum, &fixEOF);
	progressBarVal = ((double) fixEOF) * ((float) kProgressBarMax);
	progressBarVal /= (double) inputEOF;

	SetControlValue(Mac3dec->progressBar, (long) progressBarVal); // Set progess bar value

	fixEOF /= 1024;
 	NumToString(fixEOF, theString);
 	PLstrcat(theString, "\p K");
	SetControlData(Mac3dec->amountText, kControlEntireControl, 'text', PLstrlen(theString), (theString)+1); 	

	if (badFrames != oldBadFrames)
	{	oldBadFrames = badFrames;
		NumToString(badFrames, theString);
		PLstrcat(theString, "\p Frames Fixed");
		SetControlData(Mac3dec->detailsText, kControlEntireControl, 'text', PLstrlen(theString), (theString)+1);
	}
	DrawControls(Mac3dec->window);
	
	if (WaitNextEvent(everyEvent, &Event, 1, nil))
		Mac3dec->HandleEvent(&Event);
}