// mAC3dec.h: main header file


#include "lame.h"
#include <QuickTimeComponents.h>


// Resource Constants
// ------------------
#define rMenubar			128
#define rMenubarX			129
#define rMenuApple			128
#define rMenuAppleAbout			1
#define rMenuFile			129
#define rMenuFileX			229
#define rMenuFileOpen			1
#define rMenuFileRemove			2
#define rMenuFilePrefs			4
#define rMenuFileMP3Settings	5
#define rMenuFileMOVSettings	6
#define	rMenuFileQuit			8
#define rMenuDecode			130
#define rMenuDecodeStart		1
#define rMenuDecodePause		2
#define rMenuDecodeFix			4
#define rMenuDecodeOGG			99
#define rAlertAboutBox		128
#define rAlertNewAboutBox	129
#define rDialogProgress		500
#define rDialogProgressBar		1
#define rDialogProgressCancel	2
#define rDialogProgressSize		3
#define rDialogProgressFeedback	4
#define rDialogErrorBox		666
#define rDialogErrorOK			1
#define rDialogErrorText		2
#define rDialogMemError		667
#define rDialogMemErrorOK		1
#define rDialogMemErrorCancel	3
#define rDialogPrefs		999
#define rDialogPrefsOK			1
#define rDialogPrefsAltivecLbl	6
#define rDialogPrefsDest		7
#define rDialogPrefsAutoDecode	8
#define rDialogPrefsUseAltivec  9
#define rDialogPrefsDynRange	10
#define rDialogPrefsDolby		11
#define rDialogPrefsLameSample	12
#define rDialogPrefsNoProgress	13
#define rDialogMP3Settings	998
#define rDialogMP3OK			1
#define rDialogMP3nspsytune		2
#define rDialogMP3Channels		7
#define rDialogMP3Quality		8
#define rDialogMP3SamplingRate	9
#define rDialogMP3Method		11
#define rDialogMP3BitrateLabel	12
#define rDialogMP3Bitrate		13
#define rDialogMP3BitrateEdit	14
#define rDialogMP3VBRQuality	15
#define rDialogMP3MinLabel		16
#define rDialogMP3MaxLabel		17
#define rDialogMP3MinBitrate	18
#define rDialogMP3MaxBitrate	19
#define rDialogMP3VBRQLabel		20
#define rDialogYesNo		1000
#define rDialogYesNoYes			3
#define rDialogYesNoNo			2
#define rBatchDialog		5000
#define rBatchStart				1
#define rBatchFeedback			2
#define rBatchProgressBar		3
#define rBatchBytesWritten		4
#define rBatchDecodeInfo		5
#define rBatchSeparator			6
#define rBatchSampleRateLabel	7
#define rBatchNormCheckbox		8
#define rBatchTime				11
#define rBatchSampleRate		12
#define rBatchWrapper			13
#define rBatchWrapperLabel		14
#define rBatchChannelSplit		15



// Constants
// ---------
#define kPrefsVersion		0x5
#define CHUNK_SIZE			10240
#define kMaxOutputSize		2147480000
#define kInputBufferSize	102400
#define kOutputBufferSize	20480
#define kA52BufferSize		6 /* 6 blocks */ * 256 /* of 256 samples */ * 2 /* of 2 bytes each */ * 2 /* times 2 for each channel */ + 64 /* with 64 more just to be safe */
#define kProgressBarMax		10000
#define kSizeOfAIFFHeader	54
#define kNormMax			0.98f
#define kAudio44khz		0
#define kAudio48khz 	1
#define kAudioCustom	2
#define kWrapperAIFF	0
#define kWrapperWAV		1
#define kWrapperPCM		2
#define kWrapperMP3		4
#define kWrapperMOV		5
#define kWrapperAC3		9
#define kNeverFix		0
#define kAskFix		1
#define kAlwaysFix	2
#define kMyAEShowPreferences 'pref' // temp constant until I find a version of UH that includes this constant
#define kUpdateFrequency 20 // Measured in ticks now
#define kUpArrow	0x1e
#define kDownArrow	0x1f
#define kDeleteKey	0x08
#define kTabKey		0x09
#define kReturnKey	0x0D
#define kOtherDeleteKey 0x7F
#define kMinWindowWidth		420;
#define kMinWindowHeight 	207;
#define kMaxItems			256;

#define kStateStart	   -3
#define kStateCancel   -2
#define kStateDone	   -1
#define kStateIdle		0
#define kStateDecoding	1
//#define kStateFixing	2
#define kStatePaused	3


const Rect	kRectWindowSize =		{75,	50,		282,	470};
const Rect	kRectList =				{75,	13,		197,	232};
const Rect	kRectStartButton =		{177,	300,	197,	397};
const Rect	kRectProgressBar =		{29,	13,		46,		405};
const Rect	kRectSeparator = 		{59,	13,		72,		405};
const Rect	kRectWrapper =			{72,	325,	92,		405};
const Rect	kRectSampleRate =		{94,	325,	114,	405};
const Rect	kRectMP3Settings = 		{96,	326,	112,	403};
const Rect	kRectNormToggle = 		{123,	256,	141,	338};
const Rect	kRectNormGToggle = 		{123,	340,	141,	410};
const Rect	kRectChannelSplit = 	{143,	256,	161,	410};
const Rect	kRectDecodeText =		{8,		13,		28,		350};
const Rect	kRectTimeText =			{8,		354,	28,		405};
const Rect	kRectAmountText =		{47,	13,		61,		 76};
const Rect	kRectDetailsText =		{47,	77,		61,		405};
const Rect	kRectWrapperText =		{76,	256,	96,		325};
const Rect	kRectSampleRateText =	{98,	256,	118,	325};


// Structures
// ----------
typedef struct
{	SoundConverter outputSC;
	SoundComponentData outputFormat;
	SoundComponentData inputFormat;
	unsigned long inputBufferFrames;
	unsigned long inputBufferBytes;
	unsigned long outputBytes;
	unsigned long actualOutputFrames;
	unsigned long actualOutputSize;
	unsigned long totalBytesWritten;
} SoundInfo;

#define kLFE	0
#define kLeft	1
#define kCenter	2
#define kRight	3
#define kLeftS	4
#define kRightS	5

struct SplitInfo
{	FSSpec fs[6];
	short ref[6];
	
	unsigned long bytes[6];
	long write[6];	
};


struct MP3Info
{	Boolean		mono;
	Boolean		joint;
	Boolean		fast;
	Boolean		high;
	Boolean		vbr;
	Boolean		abr;
	Boolean		nspsytune;
	
	int		bitrate;
	int		minBitrate;
	int		maxBitrate;
	int		sample;
	int		vbrQuality;
};


/*typedef struct {
	long	atomSize;			// how big this structure is (big endian)
	long	atomType;			// atom type
	char	waveData[28];
} AtomQDMCWaveFormatEx;


typedef struct 
{	AudioFormatAtom			formatData;
	AtomQDMCWaveFormatEx	endianData;
	AudioTerminatorAtom		terminatorData;
} AudioCompressionAtom;*/

typedef struct
{	AudioFormatAtom		formatData;
	AudioEndianAtom		endianData;
	AudioTerminatorAtom terminatorData;
} AudioCompressionAtom, *AudioCompressionAtomPtr;





// Function Prototypes
// -------------------

void HandleError(Str255, unsigned long, Boolean);
void HandleErrorFourCC(Str255, OSType, Boolean);
pascal OSErr HandleDragTrack(DragTrackingMessage, WindowRef, void *, DragRef);
pascal OSErr HandleDragReceive(WindowRef, void *, DragRef);
pascal void NavServicesSuxEventProc(NavEventCallbackMessage, NavCBRecPtr, NavCallBackUserData);
void NotEnoughMemoryErr(void);
Boolean	EncodeProgress(long, long);



// Class Definitions
// -----------------

class Decoder
{
	public:
		Decoder(void);
		~Decoder(void);

		void		FillBuffer(unsigned char**, long);
		void		EventLoop(void);
		void		HandleEvent(EventRecord*);
		void		HandleMouseDown(EventRecord*);
		void		HandleKeyDown(unsigned char, Boolean);
		void		HandleMenuChoice(long);
		void		HandleContentClick(EventRecord*);
		void		AboutBox(void);
		void		Resize(short, short);
		void		Details(int, int, int, int, Boolean);
		void		Time(unsigned long, long);
		void		Feedback(Boolean);
		void		Add(FSSpec*);
		void		Remove(short);
		void		GetFolderWithNav(FSSpec*, Str255);
		void		GetFileWithNav(void);
		Boolean 	PutFileWithNav(StringPtr, FSSpec*, short);
		void		GetName(StringPtr, int);
		void		GetInputFile(int);
		void		GetOutputFile(Str63);
		
		void		Start(void);
		float		Normalize(int);
		float		NormalizeAC3(void);
		float		NormalizeQT(void);
		float		NormalizeGlobal(void);
		void		NormTest(short*, long);
		void		NormGrow(short*, long);
		void		Transcode(int);
		void		FixAC3(void);
		OSErr		GetOutputFormat(SoundComponentData*, Boolean);
		OSErr		GetQuickTimeOutputFormat(SoundComponentData* theSCD);
		Boolean		CheckQT(FSSpec*);
		void		InitInputAC3(void);
		void		InitInputQT(void);
		void		WAVHeader(short, Boolean, long, short, Boolean);
		void		InitOutputAIFF(void);
		void		InitOutputMOV(void);
		void		InitOutputMP3(MP3Info*);
		int			SeekSync(int*, int*, int*);
		void		WriteFrame(unsigned char*, long);
		void		Progress(long);
		void		Cleanup(void);
		void		PrepChannel(int, int);
		void		SplitAC3(void);
		void		SplitWrite(char*, int, char);

	
		// Properties
		FSSpec				items[256];
		FSSpec				inputSpec;
		FSSpec				outputSpec;
		FSSpec				folderSpec;
		FSRef				inputBig;
		SInt16				inputRef;
		short				input;
		short				output;
		long long			inputFileSize;
		long long			inputEOF;
		long				outputFileSize;
		long				amountDone;
		SplitInfo			split;
		Boolean				active;
		char				state;
		short				numItems;
		Str255				titleText;
		
		// Memory
		unsigned char*		inputBuffer;
		Ptr					outputBuffer;
		Ptr					a52Buffer;
		Ptr					qtOutBuffer;
		UInt32				ticksStart, ticksCurrent;
		Boolean				normPass;
		short				normVal;
		float				normGrow;
		long				aiffEOF;
		long				bytesWritten;

		// SoundConverter
		SoundInfo			info;
		SoundInfo			qtInfo;

		// A52
		sample_t*			samples_ptr;
		int					flags, sample_rate, bit_rate;
		a52_state_t*		a52_state;
		
		// QuickTime Input
		Boolean							qt;
		short							qtRef;
		Movie							movie;
		Track							track;
		Media							media;
		AudioCompressionAtom*			decomAtom;
		Ptr								decomBuffer;
		Handle							sourceHandle;
		ExtendedSoundComponentData		ac3CompData;
		ExtendedSoundComponentData		qtInCompData;
		ExtendedSoundComponentData		qtOutCompData;
		SoundConverterFillBufferDataUPP	fillBufferUPP;
		SoundConverterFillBufferDataUPP	qtFillBufferUPP;
		TimeValue						time, duration;
		Boolean							moreSource;
		
		// QuickTime output
		Movie						outMovie;
		Track						outTrack;
		Media						outMedia;
		CompressionInfo				compressionFactor;
		SoundDescriptionV1Handle	hSoundDescription;
		Boolean						outputFormatIsVBR;
		unsigned long				numberOfMediaSamples;

		// MP3 Output
		lame_global_flags	*gfp;

		// Interface
		WindowPtr		window;
		Rect			winRect;
		Rect			listRect;
		ListHandle		list;
		ControlHandle	startButton;
		ControlHandle	sampleRate;
		ControlHandle	wrapper;
		ControlHandle	mp3Settings;
		ControlHandle	normToggle;
		ControlHandle	normGlobalToggle;
		ControlHandle	splitToggle;
		ControlHandle	progressBar;
		ControlHandle	decodeText;
		ControlHandle	timeText;
		ControlHandle	amountText;
		ControlHandle	detailsText;
		ControlHandle	sampleRateLabel;
		ControlHandle	wrapperLabel;
		ControlHandle	separator;
};


class Preferences
{
	public:
		Preferences(void);
		~Preferences(void);
		
		void	Dialog(void);
		void	MP3Dialog(void);
		OSErr	Read(void);
		OSErr	Write(void);
	
		// Properties
		char	audioOutput;
		char	wrapper;
		Boolean channelSplit;
		Boolean chooseSave;
		Boolean	hasAltivec;
		Boolean useAltivec;
		Boolean osX;
		Boolean	useRefs;
		Boolean autoDecode;
		Boolean	normalize;
		Boolean normalizeGlobal;
		Boolean a52nodynrng;
		Boolean a52dolby;
		Boolean lameResample;
		Boolean useProgressBar;
		
		SoundComponentData	customSettings;
		SoundComponentData	movSettings;
		Handle compressionParams;
		
		Handle	customHandle;
		Handle	movHandle;
		
		Rect	winSize;
		
		MP3Info	mp3info;
	
	private:
	
};